﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace XamDataGridDropDragTest
{
    public class DataModel : INotifyPropertyChanged
    {

        public DataModel()
        {
            createData();
        }

        private void createData()
        {
            for (int i = 0; i < 100; i++)
            {
                PersonObject tmp = new PersonObject();
                tmp.Name = "Person" + i.ToString();
                DataSource.Add(tmp);
            }
        }

        /// <summary>
        /// _dataSource
        /// </summary>
        private ObservableCollection<PersonObject> _dataSource;

        /// <summary>
        /// DataSource
        /// </summary>			
        public ObservableCollection<PersonObject> DataSource
        {
            get {
                if (_dataSource == null)
                    _dataSource = new ObservableCollection<PersonObject>();
                return _dataSource; }
            set { _dataSource = value; OnPropertyChanged("DataSource"); }
        }

        private void OnPropertyChanged(string propertyName)
        {

            if (PropertyChanged != null)       
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
        public event PropertyChangedEventHandler PropertyChanged;
    }


    public class PersonObject :INotifyPropertyChanged
    {
        public PersonObject(){}
        /// <summary>
        /// _name
        /// </summary>
        private String _name;

        /// <summary>
        /// Name
        /// </summary>			
        public String Name
        {
            get { return _name; }
            set { _name = value; OnPropertyChanged("Name"); }
        }

        /// <summary>
        /// _christianName
        /// </summary>
        private String _christianName;

        /// <summary>
        /// ChristianName
        /// </summary>			
        public String ChristianName
        {
            get { return _christianName; }
            set { _christianName = value; OnPropertyChanged("ChristianName"); }
        }
        


        private void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
